import QtQuick 2.4
import QtQuick.Controls 1.3
import QtQuick.Window 2.2
import QtQuick.Dialogs 1.2

import "components/controls" as Controls
import "components/window" as Windows
import "components/screens" as Screens

Windows.StyledWindow {
    id: root

    title: qsTr("Lovci")
    width: pixelSize * 20
    height: pixelSize * 10 + 75
    visible: true
    color: "white"
//http://localhost:8000
    property string rawMap: ""
    property var rawRows: new Array
    property bool inited: false
    property double pixelSize: 60
    property var player
    property var enemy
    property var chest: new Array
    property var goScreen
    property string ip: ""
    property bool restart: false

    property color primaryColor: "#00C0FF"
    property color secondaryColor: "#232020"
    property color ternaryColor: "#333333"
    property color lineColor: "lightGray"
    property color cancelColor: "#FE2126"

    Controls.Bar {
        id: infoBar

        height: 30
        color: "#00568E"
    }

    Screens.InitScreen {
        anchors.fill: parent

    }

    //border
    Rectangle {
        y: 30 - border.width
        x: 5 * root.pixelSize - border.width
        width: height + 2 *border.width
        height: 10 * root.pixelSize + 2 * border.width
        opacity: inited

        color: "transparent"
        border.color: lineColor
        border.width: 2


        Behavior on opacity {
            NumberAnimation { duration: 200 }
        }
    }

    //init map
    function initMap(ip) {
        var request = new XMLHttpRequest()
        request.open("GET", ip + "/start")
        request.onreadystatechange = function() {
            if(request.readyState == XMLHttpRequest.DONE) {
                if(request.status == 200) {
                    console.log(request.responseText)
                    rawMap = request.responseText
                }
                else
                    console.log("shit")
            }
        }
        request.send()
        for(var i = 0; i < 10; i++) {
            chest[i] = new Array
        }
    }

    Item {
        id: keys
        anchors.fill: parent
        focus: true
        Keys.onPressed: {
            if (event.key == Qt.Key_Up) {
                move("N")
                event.accepted = true;
            }

            else if (event.key == Qt.Key_Down) {
                move("D")
                event.accepted = true;
            }

            else if (event.key == Qt.Key_Left) {
                move("L")
                event.accepted = true;
            }

            else if (event.key == Qt.Key_Right) {
                move("P")
                event.accepted = true;
            }

            else if(event.key == Qt.Key_R) {
                inited = false
                restart = true
                root.goScreen.hide()
                initMap(root.ip)
                event.accepted = true
            }
        }
    }

    //moving
    function move(direction) {
        console.log("goo")
        var request = new XMLHttpRequest()
        request.open("GET", root.ip + "/tah?id="+ parseInt(infoBar.iD) + "&pohyb=" + direction)
        request.onreadystatechange = function() {
            if(request.readyState == XMLHttpRequest.DONE) {
                if(request.status == 200) {
                    console.log(request.responseText)
                    rawMap = request.responseText
                }
                else;
                    console.log("shit move")
            }
        }
        request.send()
    }

    onRawMapChanged: {
        var offset = 55
        var sideOffset = 5 * root.pixelSize
        console.log("MAP " + Map.split(rawMap))
        rawRows = Map.split(rawMap)

        if(Map.checkEndOfGame(rawRows[0]) != "") {
            root.goScreen.score = Map.checkEndOfGame(rawRows[0])
            root.goScreen.show()
            return
        }

        //header?
        infoBar.iD = rawRows[0]
        infoBar.movesLeft = rawRows[1]
        var playerData = Map.splitPlayerData(rawRows[12])
        var enemy = Map.splitPlayerData(rawRows[13])
        if(enemy.length > 2)
            console.log("Enemy mada faqa")
        infoBar.total = playerData[3]
        infoBar.carry = playerData[2]

        //default hidden
        for(var key in chest)
            for(var innerKey in chest[key]) {
                chest[key][innerKey].visible = false
            }

        //here comes the map
        for(var i = 2; i < 12; i++) {
            for(var key in rawRows[i]) {
                if(key % 2) {
                    var y = parseInt(i - 2)
                    var x = Math.floor(parseInt(key / 2))

                    switch(rawRows[i][key - 1] + rawRows[i][key]) {

                    case "..":
                        //nothing literally
                        break;


                    case "XX":
                        if(!inited) {
                            var component = Qt.createComponent("components/physical/Wall.qml")
                            var o = component.createObject(root)
                            o.x = root.pixelSize * x + sideOffset
                            o.y = root.pixelSize * y + offset
                        }

                        break;

                    case "--":
                    case "++":
                        if(!inited) {
                            var component = Qt.createComponent("components/physical/Base.qml")
                            var o = component.createObject(root)
                            o.x = root.pixelSize * x + sideOffset
                            o.y = root.pixelSize * y + offset
                        }
                        break;


                    default:
                        if(!inited) {
                            var component = Qt.createComponent("components/physical/Chest.qml")
                            chest[x][y] = component.createObject(root)
                            chest[x][y].x = root.pixelSize * x + sideOffset
                            chest[x][y].y = root.pixelSize * y + offset
                            chest[x][y].value = rawRows[i][key - 1] + rawRows[i][key]
                            chest[x][y].visible = true
                        }
                        else {
                            chest[x][y].x = root.pixelSize * x + sideOffset
                            chest[x][y].y = root.pixelSize * y + offset
                            chest[x][y].visible = true
                            chest[x][y].value = rawRows[i][key - 1] + rawRows[i][key]
                        }
                        break;
                    }
                }
            }
        }

        //player pos && go screen
        if(!inited  && !restart) {
            var component = Qt.createComponent("components/physical/Player.qml")
            root.player = component.createObject(root)

            if(enemy.length > 2) {
                var component = Qt.createComponent("components/physical/Player.qml")
                root.enemy = component.createObject(root)
            }

            var component = Qt.createComponent("components/controls/GameOverScreen.qml")
            root.goScreen = component.createObject(root)

            root.goScreen.y = 25
            root.goScreen.width = root.width
            root.goScreen.height = root.height - 25
            root.goScreen.z = 10
            root.goScreen.hide()
        }
        if(enemy.length > 2) {
            root.enemy.x = root.pixelSize * (parseInt(enemy[0]) - 1) + sideOffset
            root.enemy.y = root.pixelSize * (parseInt(enemy[1]) - 1) + offset
            root.enemy.z = 1
        }

        player.x = root.pixelSize * (parseInt(playerData[0]) - 1) + sideOffset
        player.y = root.pixelSize * (parseInt(playerData[1]) - 1) + offset
        player.z = 1
        inited = true

        restart = false

    }
}











